import { IPromise } from '@pilotlab/result';
import { Signal } from '@pilotlab/signals';
import INode from './interfaces/iNode';
import INodeNavigator from './interfaces/iNodeNavigator';
import NodeNavigationTracker from './nodeNavigationTracker';
export declare class NodeNavigator<TNode extends INode> implements INodeNavigator {
    constructor(rootNode: TNode, historyMax?: number);
    private _rootNode;
    private _trackerRunning;
    private _trackerWaiting;
    private _historyIndex;
    readonly history: string[];
    private _history;
    readonly historyMax: number;
    private _historyMax;
    internalNodeStart: INode;
    arrivedAtNode: Signal<NodeNavigationTracker<TNode>>;
    to(pathDestination: string, pathSegmentDelimiter?: string, isInterruptCurrent?: boolean, forEachParentSegment?: (nodeCurrent: TNode, nodeParent: TNode) => IPromise<any>, forEachChildSegment?: (nodeCurrent: TNode, nodeChild: TNode) => IPromise<any>, isUpdateHistory?: boolean): NodeNavigationTracker<TNode>;
    private _runTracker(tracker);
    updateHistory(pathCurrent: string): void;
    up(isInterruptCurrent?: boolean, forEachParentSegment?: (nodeCurrent: TNode, nodeParent: TNode) => IPromise<any>, forEachChildSegment?: (nodeCurrent: TNode, nodeChild: TNode) => IPromise<any>): NodeNavigationTracker<TNode>;
    back(isInterruptCurrent?: boolean, forEachParentSegment?: (nodeCurrent: TNode, nodeParent: TNode) => IPromise<any>, forEachChildSegment?: (nodeCurrent: TNode, nodeChild: TNode) => IPromise<any>): NodeNavigationTracker<TNode>;
    forward(isInterruptCurrent?: boolean, forEachParentSegment?: (nodeCurrent: TNode, nodeParent: TNode) => IPromise<any>, forEachChildSegment?: (nodeCurrent: TNode, nodeChild: TNode) => IPromise<any>): NodeNavigationTracker<TNode>;
    static navigatePath(nodeStart: INode, tracker: NodeNavigationTracker<any>): NodeNavigationTracker<any>;
    static getRouteFromPath(pathDestination: string, pathCurrent: string, pathSegmentDelimiter: string): string[];
    static findCommonAncestor(path1: string, path2: string, pathSegmentDelimiter: string): string;
    private static _navigateToNextSegmentInRoute(nodeCurrent, route, tracker);
    private static _arriveAtNode(tracker, nodeCurrent, isCompleted, isInterrupted, isError?);
}
export default NodeNavigator;
